#include <avr/io.h> 
#define F_CPU 400000UL 
#include <util/delay.h> 

#define DDR  DDRB 
#define PORT PORTB 
#define PIN  PINB 
// 
#define SDA 1 
#define SCL 0 

#define SCL_set() (PORT |= _BV(SCL)) 
#define SCL_clr() (PORT &= ~_BV(SCL)) 
#define SCL_out() (DDR  |= _BV(SCL)) 

#define SDA_set() (PORT |= _BV(SDA)) 
#define SDA_clr() (PORT &= ~_BV(SDA)) 
#define SDA_read() (PIN  & _BV(SDA)) 
#define SDA_out() (DDR  |= _BV(SDA)) 
#define SDA_in()  (DDR  &= ~_BV(SDA)) 

//////////////////////////////////////////////////////////////////////////////////////////// 
void delay(void) 
{ 
 _delay_us(10); 
} 
//////////////////////////////////////////////////////////////////////////////////////////// 
void i2c_write(unsigned char data) 
{ 
SDA_out(); 
SCL_out(); 
char index; 

 SCL_clr(); 
 delay(); 
 for(index=0; index<9; index++)// HERE WAS MY MISTAKE :) i repeat it 9 times because it doesn't matter of my ack :) 
 { 
  if(data & 0x80) 
  SDA_set(); 
  else 
  SDA_clr(); 
  delay(); 
  SCL_set(); 
  delay(); 
  SCL_clr(); 
  delay(); 
  data<<=1; 
 } 
SDA_clr(); 
} 
/////////////////////////////////////////////////////////////////////////////////////////// 
unsigned char i2c_read(unsigned char ACK) 
{ 
SDA_in(); 
SCL_out(); 

unsigned char data=0x00; 
char index; 

SCL_clr(); 
 for(index=0; index<8; index++) 
 { 
  delay(); 
  SCL_set(); 
  delay(); 
  data<<=1; 
  if(SDA_read()) 
  data++; 
  delay(); 
  SCL_clr(); 
 } 

 if(ACK==0x00) 
 SDA_set(); 
 else 
 SDA_clr(); 
 delay(); 
 SCL_set(); 
 delay(); 
 SCL_clr(); 

return data; 
} 
/////////////////////////////////////////////////////////////////////////////////////////// 
void i2c_start(void) 
{ 
SCL_out(); 
SDA_out(); 

 SDA_set(); 
 delay(); 
 SCL_set(); 
 delay(); 
 SDA_clr(); 
 delay(); 
 SCL_clr(); 
} 
/////////////////////////////////////////////////////////////////////////////////////////// 
void i2c_stop(void) 
{ 
SCL_out(); 
SDA_out(); 
  
 SDA_clr(); 
 delay(); 
 SCL_set(); 
 delay(); 
 SDA_set(); 
 delay(); 

} 
