#include <stdio.h>
#include <avr/io.h>
#include "uart.h"
#include <stdlib.h>
#include <util/delay.h>

char i,status;

//UART Initialisierung

#define BAUD 19200
#define FOSC 4000000
#define MYUBRR FOSC/16/BAUD-1 // Equation for Calculating, UBRRn Value, asynchronus normal mode



#define T_Device_ADDRESS                   0x31   
#define T_Sensor_ADDRESS_Config            0x01        
#define T_Sensor_ADDRESS_Config_Function   0x00        
#define T_Sensor_ADDRESS_BYTE              0x05


void USART_Init(unsigned int); 
void USART_Transmit( unsigned int);
unsigned char USART_Receive( void );
void USART_Transmit_String(char *str);

void i2c_start(void);
void i2c_stop(void);
void i2c_write(unsigned char);
unsigned char i2c_read (unsigned char);

int main(void)
	{

USART_Init(MYUBRR);
_delay_ms(100); 

 while(1) 
 {
    i2c_start();
    i2c_write(T_Device_ADDRESS);
	i2c_write(T_Sensor_ADDRESS_Config);                        //write
    i2c_write(T_Sensor_ADDRESS_Config_Function);
    i2c_stop();
 _delay_ms(100); 
    
	i2c_start();      
    i2c_write(T_Device_ADDRESS);
    i2c_write(T_Sensor_ADDRESS_BYTE);
	i2c_stop();
 _delay_ms(100); 

    i2c_start();
	i2c_write(T_Device_ADDRESS);
	i=i2c_read(1);
    USART_Transmit(i); 
    i2c_stop();
	                        
    

}}
